/*-------------------------------------------------------------------------
 *
 * os.h--
 *	  System specific header for Postgres for BeOS/X86
 *
 *
 * Copyright (c) 1998, Cyril VELTER
 *
 *-------------------------------------------------------------------------
 */
 
#define INTEL
#define USE_POSIX_TIME
#define HAS_TEST_AND_SET

#include "errno.h"
#include "stdio.h"

/* lock type */
typedef unsigned int slock_t;

/*#include <netinet/in.h>
#include <arpa/inet.h>
*/


/* suppress min and max define */

#undef min
#undef max

/* Not defined in BeOS (used by pqcomm.c) */
#define SIGURG 22

/* Not defined in BeOS (is always used for TCP) */
#define getprotobyname(a) (struct protoent*)malloc(sizeof(struct protoent)); \
		pe->p_proto=IPPROTO_TCP

/* Not defined in BeOS */
/*#define isascii(c)	((unsigned)(c)<=0177)*/

/* Not defined in BeOS */
#define F_SETOWN 'fset'



/*
#ifdef __cplusplus
extern "C" {
#endif
#include "socket.h"
int besocket(int family, int type, int proto);
int bebind(int fd, const struct sockaddr *addr, int size);
int begetsockname(int fd, struct sockaddr *addr, int *size);
int begetpeername(int fd, struct sockaddr *addr, int *size);
ssize_t berecvfrom(int fd, void *buf, size_t size, int flags,
			 struct sockaddr *from, int *fromlen);
ssize_t besendto(int fd, const void *buf, size_t size, int flags,
		   const struct sockaddr *to, int tolen);

ssize_t besend(int fd, const void *buf, size_t size, int flags);
ssize_t berecv(int fd, void *buf, size_t size, int flags);


int beconnect(int fd, const struct sockaddr *addr, int size);
int beaccept(int fd, struct sockaddr *addr, int *size);


int belisten(int fd, int backlog);
int beclosesocket(int fd);
int besetsockopt(int sd, int prot, int opt, const void *data, unsigned datasize);

int beselect(int nbits, 
		   struct fd_set *rbits, 
		   struct fd_set *wbits, 
		   struct fd_set *ebits, 
		   struct timeval *timeout);

void sflush(int fd);

void sclflush(int fd);

double bestrtod(char* num,char** endptr);

int begeteuid();


#ifdef __cplusplus
}
#endif

*/
#include <spbesockets.h>

/* Redirect socket functions to use the socket fd driver */
#define socket(a,b,c) besocket(a,b,c)
#define bind(a,b,c) bebind(a,b,c)
#define getsockname(a,b,c) begetsockname(a,b,c)
#define getpeername(a,b,c) begetpeername(a,b,c)
#define recvfrom(a,b,c,d,e,f) berecvfrom(a,b,c,d,e,f)
#define sendto(a,b,c,d,e,f) besendto(a,b,c,d,e,f)
#define recv(a,b,c,d) berecv(a,b,c,d)
#define send(a,b,c,d) besend(a,b,c,d)
#define connect(a,b,c) beconnect(a,b,c)
#define accept(a,b,c) beaccept(a,b,c)
#define listen(a,b) belisten(a,b)
#define closesocket(a) beclosesocket(a)
#define setsockopt(a,b,c,d,e) besetsockopt(a,b,c,d,e)
#define select(a,b,c,d,e) beselect(a,b,c,d,e)

/* Redirect geteuid to cheat about uid (BeOS is not multi user at this time) */
/* #define geteuid(a) begeteuid(a)*/ 

/* Redirect strtod to handle underflow in float8 */
/*#define strtod(a,b) bestrtod(a,b)*/
#define NOFILE -1

/* On BeOS, isinf = !finite */
#define isinf(a) beisinf(a)

/* snprintf doesn't exist on beos, map to sprintf*/
/*#define snprintf(a,b,c,d) sprintf(a,c,d)*/


/*void cleanupshm2();*/
